unit ShellTree_Unit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ShellTree, ComCtrls, StdCtrls, SHLOBJ, ExtCtrls,  ActiveX, CommCtrl,
  Menus;

type
  TForm1 = class(TForm)
    DirectoryLabel: TPanel;
    Quit: TButton;
    ShellTree1: TShellTree;
    Label3: TLabel;
    Pages: TPageControl;
    RootOptions: TTabSheet;
    PidlRoot: TRadioGroup;
    GroupBox1: TGroupBox;
    RootUsePidl: TCheckBox;
    SetRootDir: TButton;
    RootDir: TEdit;
    Button1: TButton;
    Button3: TButton;
    Standard: TTabSheet;
    Path: TEdit;
    Label1: TLabel;
    Misc: TGroupBox;
    UpdateMode: TGroupBox;
    UpdAuto: TCheckBox;
    UpdAutoRec: TCheckBox;
    Options: TGroupBox;
    CB_TF_FOLDERS: TCheckBox;
    CB_TF_NONFOLDERS: TCheckBox;
    CB_TF_HIDDEN: TCheckBox;
    FileOptions: TTabSheet;
    GroupBox2: TGroupBox;
    FileMask: TEdit;
    FileMaskUse: TCheckBox;
    ChangeFileMask: TButton;
    FileSortOrder: TRadioGroup;
    FileSorttype: TRadioGroup;
    Update: TButton;
    ReadOnly: TCheckBox;
    UpdSel: TButton;
    ShowOptions: TGroupBox;
    ShowSharedOverlay: TCheckBox;
    ShowLinkOverlay: TCheckBox;
    ShowVirtualFolders: TCheckBox;
    ShowIcons: TCheckBox;
    EditName: TButton;
    PopupMenu1: TPopupMenu;
    Popupentry11: TMenuItem;
    Popupentry21: TMenuItem;
    PopupMenuMode: TCheckBox;
    ShowMessages: TCheckBox;
    procedure FormShow(Sender: TObject);
    procedure ShellTree1Change(Sender: TObject; Node: TTreeNode);
    procedure PidlRootClick(Sender: TObject);
    procedure QuitClick(Sender: TObject);
    procedure RootUsePidlClick(Sender: TObject);
    procedure SetRootDirClick(Sender: TObject);
    procedure RootDirKeyPress(Sender: TObject; var Key: Char);
    procedure PathKeyPress(Sender: TObject; var Key: Char);
    procedure CB_TF_FOLDERSClick(Sender: TObject);
    procedure CB_TF_NONFOLDERSClick(Sender: TObject);
    procedure CB_TF_HIDDENClick(Sender: TObject);
    procedure UpdateClick(Sender: TObject);
    procedure UpdAutoClick(Sender: TObject);
    procedure UpdAutoRecClick(Sender: TObject);
    procedure ShellTree1Expanded(Sender: TObject; Node: TTreeNode);
    procedure ShellTree1Collapsing(Sender: TObject; Node: TTreeNode;
      var AllowCollapse: Boolean);
    procedure ShellTree1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure ShowIconsClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ShowVirtualFoldersClick(Sender: TObject);
    procedure FileMaskUseClick(Sender: TObject);
    procedure ChangeFileMaskClick(Sender: TObject);
    procedure FileSorttypeClick(Sender: TObject);
    procedure FileSortOrderClick(Sender: TObject);
    procedure ShellTree1Expanding(Sender: TObject; Node: TTreeNode;
      var AllowExpansion: Boolean);
    procedure ShellTree1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Button3Click(Sender: TObject);
    procedure ReadOnlyClick(Sender: TObject);
    procedure EditNameClick(Sender: TObject);
    procedure UpdSelClick(Sender: TObject);
    procedure ShowSharedOverlayClick(Sender: TObject);
    procedure ShowLinkOverlayClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Popupentry11Click(Sender: TObject);
    procedure Popupentry21Click(Sender: TObject);
    procedure PopupMenuModeClick(Sender: TObject);
    procedure ShowMessagesClick(Sender: TObject);
    procedure ShellTree1PopupMenu(Node: TShellNode; var Allow: Boolean);
  private
    { Private declarations }
  protected
  public
    Pidl1 : PItemidList;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormShow(Sender: TObject);
begin
  RootUsePidl.Checked:=Shelltree1.RootUsePidl;
  RootDir.Text:=ShellTree1.RootDir;
  UpdAuto.Checked:=ShellTree1.UpdAuto;
  UpdAutoRec.Checked:=Shelltree1.UpdAutoRec;
  CB_TF_FOLDERS.Checked     :=(TF_FOLDERS in Shelltree1.Options);
  CB_TF_NONFOLDERS.Checked  :=(TF_NONFOLDERS in Shelltree1.Options);
  CB_TF_HIDDEN.Checked      :=(TF_HIDDEN in Shelltree1.Options);
  PidlRoot.ItemIndex        :=Byte(ShellTree1.RootPidl);
  ShowIcons.Checked         :=ShellTree1.ShowIcons;
  ShowVirtualFolders.Checked:=ShellTree1.ShowVirtualFolders;
  FileMask.Text             :=ShellTree1.Filemask;
  FileMaskUse.Checked       :=ShellTree1.FileMaskUse;
  FileSorttype.ItemIndex    :=Byte(ShellTree1.FileSortType);
  FileSortOrder.ItemIndex   :=Byte(ShellTree1.FileSortOrder);
  ReadOnly.Checked          :=Shelltree1.ReadOnly;
  ShowSharedOverlay.Checked :=Shelltree1.ShowSharedOverlay;
  ShowLinkOverlay.Checked   :=Shelltree1.ShowLinkOverlay;
  PopupMenuMode.Checked     :=(Shelltree1.PopupMenuMode=pmm_System);
  ShowMessages.Checked      :=Shelltree1.ShowMessages;
  Pages.ActivePage          :=Standard;
end;

procedure TForm1.ShellTree1Change(Sender: TObject; Node: TTreeNode);
begin
  DirectoryLabel.Caption:=ShellTree1.Path;
  Path.Text:=DirectoryLabel.Caption;
  UpdSel.Enabled:=Assigned(Shelltree1.Selected);
  IF NOT Assigned(Shelltree1.Selected) Then exit;
  EditName.Enabled:=(TShellNode(Shelltree1.Selected).HasAttribute(SFGAO_CANRENAME))
    AND NOT Shelltree1.ReadOnly;
end;

procedure TForm1.PidlRootClick(Sender: TObject);
Var
  T : TPidls;
begin
  Case PidlRoot.ItemIndex OF
    0  : T:=PIDL_DESKTOP;
    1  : T:=PIDL_PROGRAMS;
    2  : T:=PIDL_CONTROLS;
    3  : T:=PIDL_PRINTERS;
    4  : T:=PIDL_PERSONAL;
    5  : T:=PIDL_FAVORITES;
    6  : T:=PIDL_STARTUP;
    7  : T:=PIDL_RECENT;
    8  : T:=PIDL_SENDTO;
    9  : T:=PIDL_BITBUCKET;
   10  : T:=PIDL_STARTMENU;
   11  : T:=PIDL_DESKTOPDIRECTORY;
   12  : T:=PIDL_DRIVES;
   13  : T:=PIDL_NETWORK;
   14  : T:=PIDL_NETHOOD;
   15  : T:=PIDL_FONTS;
   16  : T:=PIDL_TEMPLATES;
   17  : begin
           T:=PIDL_USERDEFINED;
         end;
   else
     T:=PIDL_DESKTOP;
  end;
  ShellTree1.RootPIDL:=T;
end;

procedure TForm1.QuitClick(Sender: TObject);
begin
  Close;
end;

procedure TForm1.RootUsePidlClick(Sender: TObject);
begin
  Shelltree1.RootUsePidl:=RootUsePidl.Checked;
end;

procedure TForm1.SetRootDirClick(Sender: TObject);
begin
  ShellTree1.RootDir:=RootDir.Text;
  RootDir.Text:=ShellTree1.RootDir;
end;

procedure TForm1.RootDirKeyPress(Sender: TObject; var Key: Char);
begin
  IF Key=#13 Then begin
    SetRootDirClick(Sender);
    Key:=#0;
  end;
end;

procedure TForm1.PathKeyPress(Sender: TObject; var Key: Char);
begin
  IF Key=#13 Then begin
    ShellTree1.Path:=Path.Text;
    Key:=#0;
    Path.Text:=ShellTree1.Path;
  end;
end;

procedure TForm1.CB_TF_FOLDERSClick(Sender: TObject);
begin
  IF CB_TF_Folders.Checked Then
    ShellTree1.Options:=ShellTree1.Options+[TF_FOLDERS]
  else
    ShellTree1.Options:=ShellTree1.Options-[TF_FOLDERS];
end;

procedure TForm1.CB_TF_NONFOLDERSClick(Sender: TObject);
begin
  IF CB_TF_NONFolders.Checked Then
    ShellTree1.Options:=ShellTree1.Options+[TF_NONFOLDERS]
  else
    ShellTree1.Options:=ShellTree1.Options-[TF_NONFOLDERS];
end;

procedure TForm1.CB_TF_HIDDENClick(Sender: TObject);
begin
  IF CB_TF_Hidden.Checked Then
    ShellTree1.Options:=ShellTree1.Options+[TF_Hidden]
  else
    ShellTree1.Options:=ShellTree1.Options-[TF_Hidden];
end;

procedure TForm1.UpdateClick(Sender: TObject);
begin
  ShellTree1.UpdateTree;
end;

procedure TForm1.UpdAutoClick(Sender: TObject);
begin
  ShellTree1.UpdAuto:=UpdAuto.Checked;
end;

procedure TForm1.UpdAutoRecClick(Sender: TObject);
begin
  ShellTree1.UpdAutoRec:=UpdAutoRec.Checked;
end;

procedure TForm1.ShellTree1Expanded(Sender: TObject; Node: TTreeNode);
begin
//  Label2.Caption:='Number of Elements : '+InttoStr(Shelltree1.Items.Count);
end;

procedure TForm1.ShellTree1Collapsing(Sender: TObject; Node: TTreeNode;
  var AllowCollapse: Boolean);
begin
//  Label2.Caption:='Number of Elements : '+InttoStr(Shelltree1.Items.Count);
end;

procedure TForm1.ShellTree1DragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  Label3.Caption:='Drop on : '+TShellNode(ShellTree1.GetNodeAt(X,Y)).Path;
end;

procedure TForm1.ShowIconsClick(Sender: TObject);
begin
  ShellTree1.ShowIcons:=ShowIcons.Checked;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  IF Assigned(ShellTree1.Selected) Then
    ShellTree1.RootUserPidl:=ShellTree1.AbsolutePIDL;
end;

procedure TForm1.ShowVirtualFoldersClick(Sender: TObject);
begin
  ShellTree1.ShowVirtualFolders:=ShowVirtualFolders.Checked;
end;

procedure TForm1.FileMaskUseClick(Sender: TObject);
begin
  ShellTree1.FileMaskUse:=FileMaskUse.Checked;
end;

procedure TForm1.ChangeFileMaskClick(Sender: TObject);
begin
  Shelltree1.FileMask:=Filemask.text;
end;

procedure TForm1.FileSorttypeClick(Sender: TObject);
begin
  ShellTree1.FileSortType:=TFileSortType(FileSorttype.ItemIndex);
end;

procedure TForm1.FileSortOrderClick(Sender: TObject);
begin
  ShellTree1.FileSortOrder:=TFileSortOrder(FileSortOrder.ItemIndex);
end;

procedure TForm1.ShellTree1Expanding(Sender: TObject; Node: TTreeNode;
  var AllowExpansion: Boolean);
Var
  ShellNode : TShellNode;
begin
  ShellNode:=TShellNode(Node);
  If AllowExpansion AND (ShellNode.Text='EasyFTP') AND (ShellNode.PidlLevel=1) then begin
    IF (Application.MessageBox('TShellTree does not work correct with EasyFTP'+#13+'Do you still want to try to expand ?',
      'Known Bug',MB_OKCANCEL+MB_DEFBUTTON2+MB_ICONSTOP)<>IDOK) Then AllowExpansion:=false;
  end;
end;

procedure TForm1.ShellTree1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  IF Key=VK_F2 Then begin
    ShellTree1.Selected.EditText;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  ShellTree1.RootUserPidl:=nil;
end;



procedure TForm1.ReadOnlyClick(Sender: TObject);
begin
  Shelltree1.ReadOnly:=ReadOnly.Checked;
  EditName.Enabled:=(TShellNode(Shelltree1.Selected).HasAttribute(SFGAO_CANRENAME))
    AND NOT Shelltree1.ReadOnly;
end;

procedure TForm1.EditNameClick(Sender: TObject);
begin
  IF Assigned(Shelltree1.Selected) Then begin
    ShellTree1.SetFocus;
    Shelltree1.Selected.EditText;
  end;
end;

procedure TForm1.UpdSelClick(Sender: TObject);
begin
  Shelltree1.UpdateSubNodes(Shelltree1.Selected,True);
end;


procedure TForm1.ShowSharedOverlayClick(Sender: TObject);
begin
  Shelltree1.ShowSharedOverlay:=ShowSharedOverlay.Checked;
end;

procedure TForm1.ShowLinkOverlayClick(Sender: TObject);
begin
  Shelltree1.ShowLinkOverlay:=ShowLinkOverlay.Checked;
end;


procedure TForm1.Button2Click(Sender: TObject);
Var
  RN,WN : TShellNode;
begin
  RN:=Shelltree1.RootNode;
  IF RN.Pidllevel=0 Then begin
    WN:=TShellNode(RN.GetFirstChild);
    While WN<>nil DO begin
      IF WN.IsFolder Then begin
        WN.Expand(false);
        Showmessage(Wn.Text+#13+InttoStr(WN.Count));

      end;
      WN:=TShellNode(RN.GetNextChild(WN));
    end;
  end;
end;

procedure TForm1.Popupentry11Click(Sender: TObject);
begin
  Showmessage('Popupentry 1');
end;

procedure TForm1.Popupentry21Click(Sender: TObject);
begin
  Showmessage('Popupentry 2');
end;

procedure TForm1.PopupMenuModeClick(Sender: TObject);
begin
  IF PopupMenuMode.Checked Then Shelltree1.PopupMenumode:=pmm_System
    else Shelltree1.PopupMenumode:=pmm_PopupMenu;
end;

procedure TForm1.ShowMessagesClick(Sender: TObject);
begin
  Shelltree1.ShowMessages:=ShowMessages.Checked;
end;


procedure TForm1.ShellTree1PopupMenu(Node: TShellNode; var Allow: Boolean);
begin
//  Allow:=false;
end;

end.
